//*****************************************************************
//	レーダースネーキー
//		ＷＩＣＳ・ＢＡＳＥプログラム集よりの移植
//  Ａｒｒａｎｇｅｄ　１９９７  ｂｙ  ＡＩＧ－ＳＯＦＴ
//*****************************************************************
// for V3.2 later

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

width(0)
int gwx,gwy
getWidth(gwx,gwy):// グラフィックモードで画面幅を取得 / Get screen width by graphics mode

// 定数＆変数定義
enum
	GWX	=96		:// 実画面横幅
	GWY	=31		:// 実画面縦幅
	WX	=40		:// ゲーム画面横幅
	WY	=25		:// ゲーム画面縦幅
// ゲームキャラクターの表示は全て全角なので、画面幅はGWX/2
	CX	=((GWX/2-WX)/2*2)	:// ゲーム画面を実画面の真ん中に持ってくる
	CY	=((GWY-WY)/2)

	FWX	=33		:// フィールドｘ幅
	FWY	=29		:// フィールドｙ幅
	FHX	=4		:// フィールドホームｘ座標
	FHY	=4		:// フィールドホームｙ座標
	FEX	=28		:// フィールドエンドｘ座標
	FEY	=25		:// フィールドエンドｙ座標
	FHOME=(FHX+FHY*FWX)	:// フィールドホームアドレス

// 仮想画面内のキャラクターコード
	SPACE	=' '	:// 空間
	KABE	='#'	:// 壁
	DOU		='o'	:// 蛇の胴体
	KAO		='@'	:// 蛇の顔
	KAO2	=(KAO+1):// 蛇の顔(別向き)
	KAERU	='$'	:// 蛙

	TWX	=9			:// 一度に表示する仮想画面内のｘ幅
	TWY	=8			:// 一度に表示する仮想画面内のｙ幅
	T1X	=3			:// １キャラクター表示サイズｘ
	T1Y	=3			:// １キャラクター表示サイズｙ
	T1XY=(T1X*T1Y)	:// １キャラクター必要データ数
	
	// キーコード
	KUP		='8'
	KRIGHT	='6'
	KLEFT	='4'
	KDOWN	='2'
	KSPACE	=SPACE
	EXITKEY	='!'

	FNTSZ	=24	:// フォントサイズ
endenum

enum
	PBLACK	=&h000000ff:// BLACK
	PWHITE	=&hffffffff:// WHITE
	PCYAN	=&h00ffffff:// CYAN
	PYELLOW	=&hffff00ff:// YELLOW
endenum

int	hsc,sco		:// 得点
int	round		:// 面数
int	die			:// 終わりフラグ
dim int	v(3)={-FWX,-1,FWX,1}:// 方向別アドレス増分:上左下右

// 蛇関係の変数
int	xx,yy,ox,oy,sx,sy	:// dot座標:頭、尾、？
int	mo			:// レーダーでの尻尾の点滅
int	muki,sipo	:// 頭の向き、尻尾位置
int	shita		:// 舌の状態
int	oto			:// 鳴らす音の種類
				:// 0=音無し , 1=蛙を食べる音 , 2=向きを変える音
// 蛙関係の変数
enum
	KMAX	=5	:// 蛙の数
endenum
int	eat	:// 食べてない蛙の数
int	non	:// 蛙が自分から蛇に食べられた数＝蛇の胴体の伸びる長さ
dim int	ici(KMAX)			:// 仮想画面内アドレス
dim int	 ix(KMAX),iy(KMAX)	:// 移動先座標（ドット表示）
dim int	 rx(KMAX),ry(KMAX)	:// 現在座標（ドット表示）
dim int	der(KMAX),td(KMAX)	:// 移動方向、食べられたかどうか

str RECHIGH="RS.HSC"	:// ハイ・スコア ファイル名

//****************************************************************

// 仮想VRAM / Virtual VRAM
dim char	tvram(WX,WY)
dim char	SCWorkA(FWX*FWY):// 仮想画面＝フィールド
int	adr						:// 仮想画面内の投影アドレスホーム

//*****************************************************************
//
dim int	touchNo(10)	:// タッチエリア番号 / touch area number
int touchallcnt =0	:// タッチエリア数   / the number of touch area

//****************************************************************
// 画面初期設定

font("Migu-1M-Regular",FNTSZ):// 先にフォントを設定してからwidth()を設定する
int fzenhan
width(GWX,,fzenhan)
int xw=1:// 全角１文字の桁数 / zenkaku 1 character columus
if fzenhan then xw=2
//
int wx,wy
float fntWx,fntWy
getWidth(wx,wy,,fntWx,fntWy)
debugPrint("wx="+str$(wx)+"/wy="+str$(wy)+"/fntWx="+str$(fntWx)+"/fntWy="+str$(fntWy))
int gcx=(gwx-WX*16)/2
int gcy=(fntWy*4)
//
vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0)
apage(GPAGE0):bitmapOpen(0,0,YES):bitmapWipe()
//setTouchArea(0,0,0,0,0,YES):// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate

//****************************************************************

int ret,ky
int fp
dim int sc(0)
	hsc=0:// ハイスコアクリア
	fp=fopen(RECHIGH,"r")
	if (not fopenError(fp)) then {:// hi-score write
		fread(sc,1,fp)
		hsc=sc(0)
		fclose(fp)
	}
	
	// 乱数初期化
	srand2()

	// 通常文字フォント
	sp_init():// ここでスプライト画面は非表示になる / Hide sprite screen
	setAllFontPattern():// &h20～&h7f,&ha0～hdf
	enum
		SHITA0=&h80
		SHITA1
	endenum
	setSprite("00,00,00,00,00,00,00,00,10,00,28,00,44,00,82,02,01,04,00,88,00,50,00,20,00,00,00,00,00,00,00,00",SHITA0)
	setSprite("00,80,00,40,00,20,00,10,00,20,00,40,00,80,01,00,02,00,04,00,08,00,04,00,02,00,01,00,00,80,00,40",SHITA1)
	
	// 大キャラクターを構成する文字のフォント
	setSprite("33,33,33,33,cc,cc,cc,cc,33,33,33,33,cc,cc,cc,cc,33,33,33,33,cc,cc,cc,cc,33,33,33,33,cc,cc,cc,cc",&h100):// 白のみ
	//
	setSprite3Color("00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff",&h108)
	setSprite3Color("ff,ff,7f,ff,3f,ff,1f,ff,0f,ff,07,ff,03,ff,01,ff,00,ff,00,7f,00,3f,00,1f,00,0f,00,07,00,03,00,01",&h110)
	setSprite3Color("ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff,ff",&h118)
	setSprite3Color("80,00,c0,00,e0,00,f0,00,f8,00,fc,00,fe,00,ff,00,ff,80,ff,c0,ff,e0,ff,f0,ff,f8,ff,fc,ff,fe,ff,ff",&h120)
	setSprite3Color("00,01,00,03,00,07,00,0f,00,1f,00,3f,00,7f,00,ff,01,ff,03,ff,07,ff,0f,ff,1f,ff,3f,ff,7f,ff,ff,ff",&h128)
	setSprite3Color("ff,ff,ff,fe,ff,fc,ff,f8,ff,f0,ff,e0,ff,c0,ff,80,ff,00,fe,00,fc,00,f8,00,f0,00,e0,00,c0,00,80,00",&h130)
	setSprite3Color("ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff",&h138)
	setSprite3Color("00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00",&h140)
	setSprite3Color("ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00,ff,00",&h148)
	setSprite3Color("00,00,07,e0,08,10,10,08,10,08,26,64,26,64,20,04,20,04,23,c4,11,88,10,08,08,10,07,e0,00,00,00,00",&h150)

	dim int chspc(  T1XY)={  SPACE,  SPACE,  SPACE	,  SPACE,  SPACE,  SPACE,	  SPACE,  SPACE,  SPACE}:// 白
	dim int chkabe( T1XY)={&h100  ,&h100  ,&h100	,&h100  ,&h100  ,&h100  ,	&h100  ,&h100  ,&h100  }:// 白
	dim int chkaeru(T1XY)={&h128+1,&h118+1,&h120+1	,&h148+1,&h118+1,&h108+1,	&h140+1,&h118+1,&h138+1}:// CYAN
	dim int chdou(  T1XY)={&h128+2,&h118+2,&h120+2	,&h118+2,&h118+2,&h118+2,	&h110+2,&h118+2,&h130+2}:// YELLOW
	dim int chkao1( T1XY)={&h128+2,&h118+2,&h120+2	,&h150+2,&h118+2,&h150+2,	&h110+2,&h118+2,&h130+2}:// YELLOW
	dim int chkao2( T1XY)={&h128+2,&h150+2,&h120+2	,&h118+2,&h118+2,&h118+2,	&h110+2,&h150+2,&h130+2}:// YELLOW
	
	// ADPCM読み込み / Read ADPCM data from file
	// PCMファイルはカレントしか読まないので、.basと同じディレクトリに置く必要がある。
	// ファイル名は大文字小文字区別する / File names are case-insensitive
	int snd_appl,snd_hiq,snd_rhiq,snd_pack
	snd_appl=a_setPlayData("APL.PCM")
	snd_hiq =a_setPlayData("HIQ.PCM")
	snd_rhiq=a_setPlayData("RHIQ.PCM")
	snd_pack=a_setPlayData("SCRCH4.PCM")

	// 方向別アドレス増分
	repeat
		// その他変数
		adr=&h288:// SCWorkA内
		round=1
		sco=0
		oto=0
		die=NO
		mo=1:// 尻尾表示
		//
		title()
		SetSCWorkA()
		InitSnake()
		
		setKey((GWX-T1XY*7)/2,CY+WY+8)

		repeat
			SetKaeru()	:// 初期蛙表示
			PrScreen()	:// 画面表示
			repeat
				ret=move1(0):// 蛇のみ移動
				if ret<>0 then break
				ret=move1(1):// 蛙も移動
			until ret<>0
		until ret<>2
		//
		GameOver()
		//
		dim str menues(1)
		str title$
		if isLocalizeJapan() then {
			title$="もう一度しますか？"
			menues={"はい","いいえ"}
		} else {
			title$="Try again ?"
			menues={"Yes","No"}
		}
		switch selectMenu2(title$,menues)
			case 0
				ky=0
				break
			case 1
				ky=EXITKEY
				break
		endswitch
		removeKeys()
	until ky=EXITKEY
	// bitmapを開放する
	bitmapClose()

	// ハイスコアをファイルを書き出す
	fp=fopen(RECHIGH,"c")
	if (not fopenError(fp)) then {:// hi-score write
		sc(0)=hsc
		fwrite(sc,1,fp)
		fclose(fp)
	}
	
	// ADPCMバッファー開放 / free ADPCM data buffer
	a_end(snd_appl)
	a_end(snd_hiq )
	a_end(snd_rhiq)
	a_end(snd_pack)
end

//*****************************************************************

func MZ_LOCATE(x;int,y;int)
	locate(CX+x*2,CY+y)
endfunc

func print_score(mes;str,y;int,sco;int)
	MZ_LOCATE(29,y)  :print(mes)
	MZ_LOCATE(30,y+1):print using "%%%%%0",sco;
endfunc

func score()
	print_score("ＳＣＯＲＥ",1,sco)
	print "0"
endfunc

func hi_score()
	print_score("ＨＩ－ＳＣＯＲＥ",4,hsc)
	print "0"
endfunc

func PrRound()
	print_score("ＲＯＵＮＤ",7,round)
endfunc

func title()
// 画面初期表示 / Display initial screen
int i
	cls()
	bitmapWipe()
	InitTvram()
	tColorX68(x68TCYAN+x68HLIGHT+x68REVERSE)
	center(CY-2,localizedString("＊＊　レーダー・スネーキー　＊＊","** Rader Snaky **"))
	tColorX68(x68TWHITE+x68HLIGHT)
	// 画面枠
	for i=CY-3 to CY+WY: // 縦
		locate(CX-2   ,i): print "□"
		locate(CX+WX*2,i): print "□"
	next
	for i=CX-2 to CX+WX*2: // 横
		locate(i,CY-3 ): print "□"
		locate(i,CY+WY): print "□"
		i=i+1
	next
	for i=CX to CX+WX*2-2: // 横
		locate(i,CY-1): print "－"
		i=i+1
	next
	//
	for i=0 to 10-1
		MZ_LOCATE(27,i)
		print("｜　　　　　　　　　　　｜")
	next
		MZ_LOCATE(27,i)
		print("＋－－－－－－－－－－－＋")
	tColorX68(x68TWHITE)
	score()
	hi_score()
	PrRound()
endfunc

//*****************************************************************

func RemakeLader()
// レーダーの再表示 / Re-display rader
int i
	// 蛙の位置 / Position of frog
	for i=0 to KMAX-1
		if td(i)=0 then plot(ix(i),iy(i),1,x68TCYAN)
	next
	// 蛇の位置は頭と尻尾以外表示できないのだ！
	plot(xx,yy,1,x68TYELLOW)
	plot(ox,oy,1,x68TYELLOW)
endfunc

//*****************************************************************

func plot(x;int,y;int,mode;int,col;int)
// セミグラフィック / Semi graphics
// mode : 0=off, 1=on
	dim int dotoff(8*8)={
		0,0,0,0,0,0,0,0,
		0,PBLACK,PBLACK,PBLACK,PBLACK,PBLACK,PBLACK,0,
		0,PBLACK,PBLACK,PBLACK,PBLACK,PBLACK,PBLACK,0,
		0,PBLACK,PBLACK,PBLACK,PBLACK,PBLACK,PBLACK,0,
		0,PBLACK,PBLACK,PBLACK,PBLACK,PBLACK,PBLACK,0,
		0,PBLACK,PBLACK,PBLACK,PBLACK,PBLACK,PBLACK,0,
		0,PBLACK,PBLACK,PBLACK,PBLACK,PBLACK,PBLACK,0,
		0,0,0,0,0,0,0,0
	}
	// 水色ドット / Cyan dot
	dim int cdoton(8*8)={
		0,0,0,0,0,0,0,0,
		0,PCYAN,PCYAN,PCYAN,PCYAN,PCYAN,PCYAN,0,
		0,PCYAN,PCYAN,PCYAN,PCYAN,PCYAN,PCYAN,0,
		0,PCYAN,PCYAN,PCYAN,PCYAN,PCYAN,PCYAN,0,
		0,PCYAN,PCYAN,PCYAN,PCYAN,PCYAN,PCYAN,0,
		0,PCYAN,PCYAN,PCYAN,PCYAN,PCYAN,PCYAN,0,
		0,PCYAN,PCYAN,PCYAN,PCYAN,PCYAN,PCYAN,0,
		0,0,0,0,0,0,0,0
	}
	// 黄色ドット / Yellow dot
	dim int ydoton(8*8)={
		0,0,0,0,0,0,0,0,
		0,PYELLOW,PYELLOW,PYELLOW,PYELLOW,PYELLOW,PYELLOW,0,
		0,PYELLOW,PYELLOW,PYELLOW,PYELLOW,PYELLOW,PYELLOW,0,
		0,PYELLOW,PYELLOW,PYELLOW,PYELLOW,PYELLOW,PYELLOW,0,
		0,PYELLOW,PYELLOW,PYELLOW,PYELLOW,PYELLOW,PYELLOW,0,
		0,PYELLOW,PYELLOW,PYELLOW,PYELLOW,PYELLOW,PYELLOW,0,
		0,PYELLOW,PYELLOW,PYELLOW,PYELLOW,PYELLOW,PYELLOW,0,
		0,0,0,0,0,0,0,0
	}
	x=gcx+x*8
	y=gcy+y*8
	switch mode
		case 0:// off
			bitmapPattern(x,y,8,8,dotoff)
			break
		case 1:// on
			switch col
				case x68TCYAN
					bitmapPattern(x,y,8,8,cdoton)
					break
				case x68TYELLOW
					bitmapPattern(x,y,8,8,ydoton)
					break
			endswitch
			break
	endswitch
	bitmapImgLoad()
endfunc

//*****************************************************************

func printxy2(x;int,y;int,c;int,fsoon;int)
// 仮想VRAMに書き込まずに表示する
	// スプライトとして定義しているパターンを読み出してグラフィックに描画する
	dim int ptrn(16*16)
	sp_pat(c,ptrn):// パターン読みだし
	bitmapPattern(gcx+x*16,gcy+y*16,16,16,ptrn)
	if fsoon then bitmapImgLoad():// 即時表示更新
endfunc

func printxys(x;int,y;int,s;str,fsoon;int)
int i
	for i=0 to strlen(s)-1
		printxy2(x,y,s[i],fsoon)
		x=x+1
		if x>=WX then x=0:y=y+1
		if y>=WY then y=WY-1
	next
endfunc

func InitTvram()
// 仮想テキストＶＲＡＭ初期化 / Initialize virtual VRAM
int x,y
	for y=0 to TWY-1
		for x=0 to TWX-1
			tvram(x,y)=SPACE
		next
	next
endfunc

func PrScreen()
// 仮想画面を画面上に表示する / Display on the virtual screen
int i,k,m,c,j,jj
int ii,kk=-1
int x0,y0,x
	shita=shita+1
	// 一度に表示されるのは、adrをホームとしたTWX*TWYのブロックで、
	// 仮想画面上1キャラクターがT1X*T1Yのキャラクターで表示される
	m=(muki and 1)
	for i=0 to TWY-1: // Ｙ方向
		for k=0 to TWX-1: // Ｘ方向
			c=SCWorkA(adr+i*FWX+k)
			// キャラクターの表示
			if tvram(k,i)=c then continue:// 前と同じところは再表示しない
			// 前と変わるところだけ

			x0=k*T1X
			y0=i*T1Y
			x=x0
			jj=0
			switch c
				case KABE
					for j=0 to T1XY-1
						c=chkabe(j)
						printxy2(x,y0,c,NO)
						x=x+1
						jj=jj+1
						if jj>=3 then x=x0:y0=y0+1:jj=0
					next
					break
				case KAERU
					for j=0 to T1XY-1
						c=chkaeru(j)
						printxy2(x,y0,c,NO)
						x=x+1
						jj=jj+1
						if jj>=3 then x=x0:y0=y0+1:jj=0
					next
					break
				case DOU
					for j=0 to T1XY-1
						c=chdou(j)
						printxy2(x,y0,c,NO)
						x=x+1
						jj=jj+1
						if jj>=3 then x=x0:y0=y0+1:jj=0
					next
					break
				case KAO
					c=c+m:// 顔の向きでキャラクターを変えるため
					kk=k:// 顔の位置記録
					ii=i
					for j=0 to T1XY-1
						if m=0 then c=chkao1(j) else c=chkao2(j)
						printxy2(x,y0,c,NO)
						x=x+1
						jj=jj+1
						if jj>=3 then x=x0:y0=y0+1:jj=0
					next
					break
				default: // スペース
					for j=0 to T1XY-1
						c=chspc(j)
						printxy2(x,y0,c,NO)
						x=x+1
						jj=jj+1
						if jj>=3 then x=x0:y0=y0+1:jj=0
					next
					break
			endswitch
			tvram(k,i)=c
			bitmapImgLoad()
		next:// k
	next:// i
	//
	if (shita and 2)=0 then {:// 舌
		if kk<>-1 then {:// 通常頭は表示されるが、GameOver時だけはそうでないことがある
			x0=kk*T1X
			y0=ii*T1Y
			switch muki
				case 0:x0=x0+1:y0=y0-1:ii=ii-1:break:// 上
				case 1:x0=x0-1:y0=y0+1:kk=kk-1:break:// 左
				case 2:x0=x0+1:y0=y0+3: i=ii+1:break:// 下
				case 3:x0=x0+3:y0=y0+1:kk=kk+1:break:// 右
			endswitch
			tvram(kk,ii)=&hff:// 次回画面が更新されるようにする
			tColorX68(x68TYELLOW)
			if m=0 then {
				printxy2(x0,y0,SHITA1,YES)
			} else {
				printxy2(x0,y0,SHITA0,YES)
			}
			tColorX68(x68TWHITE)
		}
	}
	int sno
	switch oto
		case 1: // 蛙を食べる音
			sno=snd_hiq
			break
		case 2: // 頭を入れ換える音
			sno=snd_rhiq
			break
	endswitch
	if oto<>0 then PCMplay(sno,NO)
	plot(xx,yy, 1,x68TYELLOW)
	plot(ox,oy,mo,x68TYELLOW)
	ox=sx
	oy=sy
	for i=0 to KMAX-1
		if td(i)=0 then {
			plot(rx(i),ry(i),0,x68TCYAN)
			plot(ix(i),iy(i),1,x68TCYAN)
			rx(i)=ix(i)
			ry(i)=iy(i)
		}
	next
	if oto<>0 then WaitPCM(sno)
	oto=0
endfunc

//*****************************************************************

func int TurnHead()
// 頭の入れ替え / Switch between head and tail
int i,a,b
	a=adr+136
	b=0
	for i=0 to 3:// 上左下右
		if SCWorkA(a+v(i))=DOU then b=b+1
	next
	if b<>1 then return(YES):// 自分の体で行き詰まり=終わり
	SCWorkA(a   )=DOU
	SCWorkA(sipo)=KAO
	shita=1
	oto=2:// 向きを変えるの音
	adr=sipo-136
	sipo=a
	// 頭と尻尾座標入れ替え(dot)
	a=xx: xx=sx: sx=a: ox=a
	a=yy: yy=sy: sy=a: oy=a
	return(NO)
endfunc

//*****************************************************************

func MoveSipo()
// 尻尾移動 / Move tail
int i
	for i=0 to 2: // まわりを調べる
		if SCWorkA(sipo+v(i))=DOU then break
	next
	switch i
		case 0:sy=sy-1:break:// 上
		case 1:sx=sx-1:break:// 左
		case 2:sy=sy+1:break:// 下
		case 3:sx=sx+1:break:// 右
	endswitch
	SCWorkA(sipo)=SPACE
	sipo=sipo+v(i)
	mo=0:// 尻尾非表示
endfunc

//*****************************************************************

func EatKaeru(i;int)
// 蛙食べた / Eat snake
	sco=sco+round
	score()
	oto=1:// 蛙食べたの音
	td(i)=1
//	ici(i)=-1
	eat=eat-1
	plot(ix(i),iy(i),0,x68TCYAN)
endfunc

//*****************************************************************

func MoveSnake()
// 蛇の移動 / Move snake
int t,g,p,i
	if die or eat=0 then return
	mo=1:// 尻尾表示
	switch inkey()
		case KUP   :p=0:break
		case KLEFT :p=1:break
		case KDOWN :p=2:break
		case KRIGHT:p=3:break
		case KSPACE:
			die=TurnHead()
		default:
			return
	endswitch
	kbclr()
	t=g=0
	// 移動先は何？
  label"MoveSnake1"
	switch SCWorkA(adr+136+v(p))
		case DOU
			if SCWorkA(adr+136-v(p))=DOU then die=YES
			if die then break
		case KABE
			if t then return
			t=1
			p=muki:// 向きの自動変換
			goto "MoveSnake1"
		case KAERU
			for i=0 to KMAX-1
				if td(i)=0 then {
					// 蛙が重なっていることもあるので、全部チェックする
					if ici(i)=adr+136+v(p) then EatKaeru(i)
				}
			next
			g=1
			break
	endswitch
	//
	muki=p
	SCWorkA(adr+136)=DOU
	adr=adr+v(p)
	SCWorkA(adr+136)=KAO
	if g=0 then { :// スペースへ移動 / Move to space
		if non<>0 then {
			non=non-1:// 胴体長さ＋１
		} else {
			MoveSipo():// 長さ不変
		}
	}:// 蛙へ移動 : 長さ＋１（一度に２匹以上食べた時も増える長さは＋１）
	// 尻尾移動する  ＝長さ不変
	// 尻尾移動しない＝長さ＋１
	// 結局、動くのは頭と尻尾だけで、胴体部分は残像である。
	switch muki
		case 0:yy=yy-1:break:// 上 / Up
		case 1:xx=xx-1:break:// 左 / Left
		case 2:yy=yy+1:break:// 下 / Down
		case 3:xx=xx+1:break:// 右 / Right
	endswitch
endfunc

//*****************************************************************

func InitSnake()
// スネーク初期化
	muki=0:shita=0:// 向き＝上、舌＝消えている
	SCWorkA(&h310)=KAO
	SCWorkA(&h331)=DOU
	sipo=&h352
	SCWorkA(sipo) =DOU
	xx=76:yy=43
	plot(xx,yy  ,1,x68TYELLOW):// 頭
	plot(xx,yy+1,1,x68TYELLOW):// 胴体
	sx=xx
	ox=sx
	sy=yy+2
	oy=sy
	plot(sx,sy,1,x68TYELLOW):// 尻尾
endfunc

//*****************************************************************

func KaeruMove()
// 蛙移動＆方向転換
int i,w,pp,yo
	for i=0 to KMAX-1
		if die then break
		if td(i)<>0 then continue
		// 自分の移動方向に対して垂直移動ができる時は向きを変える
		// 行き先が蛇で有っても・・・
		pp=der(i) and 1:// 上=0,左=1,下=2,右=3 -> 0,1,0,1
		if SCWorkA(ici(i)+v(1-pp))<>KABE or SCWorkA(ici(i)+v(3-pp))<>KABE then {
			// 方向変換
			repeat
				w=rand2(4)
				// 前と正反対の方向か壁方向には向かない
			until (der(i) xor 2)<>w and SCWorkA(ici(i)+v(w))<>KABE
			der(i)=w
		}
		pp=der(i)
		yo=SCWorkA(ici(i)+v(pp))
		if yo=DOU then die=YES
		SCWorkA(ici(i))=SPACE
		if yo=KAO then {:// 蛇の頭に自分から入っていく
			EatKaeru(i)
			non=non+1:// 蛇の長さ＋１
			continue
		}
		ici(i)=ici(i)+v(pp)
		SCWorkA(ici(i))=KAERU
		switch der(i)
			case 0:iy(i)=iy(i)-1:break:// 上 / Up
			case 1:ix(i)=ix(i)-1:break:// 左 / Left
			case 2:iy(i)=iy(i)+1:break:// 下 / Down
			case 3:ix(i)=ix(i)+1:break:// 右 / Right
		endswitch
		if die then {
			// 次でゲームオーバーになるので、画面を食いついた場所に移す
			PCMplay(snd_pack,YES)
			adr=ici(i)-136
		}
	next
endfunc

//*****************************************************************

func SetKaeru()
// 蛙配置
int i,tx,ty,qq
	for i=0 to KMAX-1
		repeat:// 交差点に配置する
			tx=(rand2(9))*3
			ty=(rand2(8))*3
			qq=ty*FWX+tx+FHOME
		until SCWorkA(qq)=SPACE
		ici(i)=qq
		SCWorkA(qq)=KAERU
		// dot MAP座標
		ix(i)=(tx+55)
		rx(i)=ix(i)
		iy(i)=(ty+24)
		ry(i)=iy(i)
		plot(ix(i),iy(i),1,x68TCYAN)
		PCMplay(snd_hiq,NO)
		der(i)=rand2(4):// 3; 初期移動方向
		td(i)=0
		wait(0.1)
		WaitPCM(snd_hiq)
	next
	eat=i:// KMAX
	non=0
endfunc

//*****************************************************************

func SetSCWorkA()
// 仮想画面にフィールドをセットする
int x,y
	// 一旦全て埋める
	for x=0 to FWX*FWY-1
		SCWorkA(x)=KABE
	next
	// 横に道を作る
	for y=FHY to FEY
		for x=FHX to FEX
			SCWorkA(y*FWX+x)=SPACE
		next
		y=y+2:// step3
	next
	// 縦に道を作る
	for x=FHX to FEX
		for y=FHY to FEY
			SCWorkA(x+y*FWX)=SPACE
		next
		x=x+2:// step3
	next
endfunc

//*****************************************************************

func GameOver()
int i
	tColor(CTHRED)
	tAtrb(ATRB_BOLD)
	for i=1 to 6
		printxys(11,11,"\ || /",NO)
		printxys(11,12,"_GAME_",NO)
		printxys(11,13," OVER ",NO)
		printxys(11,14,"/ || \",YES)
		beep()
		vwait(16)
		if i=5 then break
		printxys(11,11,"\ || /",NO)
		printxys(11,12,"_@@@@_",NO)
		printxys(11,13," @@@@ ",NO)
		printxys(11,14,"/ || \",YES)
		vwait(20)
	next
	tColor(CTHWHITE)
	tAtrb(ATRB_NORMAL)
	if sco>hsc then {
		PCMplay(snd_appl,NO)
		tColorX68(x68TCYAN+x68REVERSE+x68HLIGHT)
		MZ_LOCATE(28,3):print localizedString("＊＊　新記録！！　＊＊","** New Record **")
		tColorX68(x68TWHITE)
		hsc=sco
		hi_score()
	}
endfunc

//*****************************************************************

func int move1(mode;int)
// 蛇・蛙移動＆画面表示など
	MoveSnake()
	if mode then KaeruMove()
	PrScreen()
	if die then return(1)
	if eat=0 then {
		int i
		round=round+1
		PrRound():// 面を進める
		for i=1 to 2: // 胴体を２縮める
			plot(sx,sy,0,x68TYELLOW)
			PCMplay(snd_hiq,NO)
			MoveSipo():// 移動方向に進める＝縮める
			vwait(11)
			WaitPCM(snd_hiq)
		next
		return(2)
	}
	vwait(10)
	return(0)
endfunc

//*****************************************************************
// 表示補助
//*****************************************************************

func center(y;int,mes;str)
// センタリング表示 / print message with centering
int x,wd=1
	// 日本語版は全角のみ、英語版は半角のみにすること
	// English is half width only and Japanese is double width only
	if isLocalizeJapan() then {
		wd=2:// 1文字の幅は2(全角)
	}
	x=(GWX-utf8Len(mes)*wd)/2:// センタリング / centering
	locate(x,y):print mes
endfunc

//*****************************************************************
// タッチキー / Touch Key
//****************************************************************

func setKey(x;int,y;int)
// キーをタッチで設定 / set touch key
	enum
		XC=3
		YC=3
		K1X=16*4
		K1Y=16*4
	endenum
	if touchallcnt =0 then {
		dim int keys( XC*YC-1)={0,KUP,0,KLEFT,KSPACE,KRIGHT,0,KDOWN,0}
		dim str disps(XC*YC-1)={" ","↑"," ","←","⇔","→"," ","↓"," "}
		touchallcnt =setTouchKeys(x*16,y*16,XC,YC,K1X,K1Y,keys,disps,"Migu-1M-Regular",touchNo)
	}
	return (touchallcnt)
endfunc

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
	if touchallcnt>0 then {
		resetAllTouchKeys(touchNo,touchallcnt)
		touchallcnt =0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

//****************************************************************

// スプライト定義 / Define sprite pattern
func setSpriteWithColor(sptrn;str,no;int,col2;int)
	// (0)16進文字列→配列
	dim char fnt(16/8*16)
	hexstrToArray(sptrn,fnt)

	// (1)フォントパターンをiOS型スプライトパターンに変換
	//locate(0,1)
	dim int ptrn(16*16)
	int i,j
	int fk=0,sk=0,col
	for i=1 to 16/8*16
		char c=fnt(fk):fk=fk+1
	//	print right$("0"+hex$(c),2);",";
		for j=0 to 7
			col=0
			if (c and bit(7-j))<>0 then col=col2:// とりあえず今は単色展開のみ
			ptrn(sk)=col
			sk=sk+1
		next
	next
//	print
	// (2)スプライトに定義
	sp_def(no,ptrn)

	// (3)仮表示 for test
//	int x=no mod 32
//	int y=no/32
//	bitmapPattern(x*16,y*16+128,16,16,ptrn)
endfunc

func setSprite(sptrn;str,no;int)
	setSpriteWithColor(sptrn,no,PWHITE)
endfunc

func setSprite3Color(sptrn;str,no;int)
// 3色設定
	setSpriteWithColor(sptrn,no+0,PWHITE)	:// WHITE
	setSpriteWithColor(sptrn,no+1,PCYAN)	:// CYAN
	setSpriteWithColor(sptrn,no+2,PYELLOW)	:// YELLOW
endfunc


func setAllFontPattern()
// &h20～&h7e,&ha1～&hdfに16*16フォントを設定する
// MZ-80Kの画面をX68で再現したものをさらにiOSで再現しやすくするため
// iOSではフォントサイズが固定できないので
//20  :	!  "  #  $  %  &  '  (  )  *  +  ,  -  .  / 
//30  : 0  1  2  3  4  5  6  7  8  9  :  ;  <  =  >  ? 
//40  : @  A  B  C  D  E  F  G  H  I  J  K  L  M  N  O 
//50  : P  Q  R  S  T  U  V  W  X  Y  Z  [  \  ]  ^  _ 
//60  : `  a  b  c  d  e  f  g  h  i  j  k  l  m  n  o 
//70  : p  q  r  s  t  u  v  w  x  y  z  {  |  }  ~	
//A0  :	｡  ｢  ｣  ､  ･  ｦ  ｧ  ｨ  ｩ  ｪ  ｫ  ｬ  ｭ  ｮ  ｯ 
//B0  : ｰ  ｱ  ｲ  ｳ  ｴ  ｵ  ｶ  ｷ  ｸ  ｹ  ｺ  ｻ  ｼ  ｽ  ｾ  ｿ 
//C0  : ﾀ  ﾁ  ﾂ  ﾃ  ﾄ  ﾅ  ﾆ  ﾇ  ﾈ  ﾉ  ﾊ  ﾋ  ﾌ  ﾍ  ﾎ  ﾏ 
//D0  : ﾐ  ﾑ  ﾒ  ﾓ  ﾔ  ﾕ  ﾖ  ﾗ  ﾘ  ﾙ  ﾚ  ﾛ  ﾜ  ﾝ  ﾞ  ﾟ 

// 20-2f
dim str ptrn16(16*6)={
// 20-2f
	"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00",
	"00,00,01,80,01,80,01,80,01,80,01,80,01,00,01,00,01,00,01,00,00,00,00,00,01,80,01,80,00,00,00,00",
	"36,00,36,00,12,00,24,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00",
	"02,10,02,10,02,10,02,10,1f,fc,1f,fc,04,20,04,20,04,20,04,20,3f,f8,3f,f8,08,40,08,40,08,40,08,40",
	"00,00,01,00,07,e0,09,30,11,18,11,00,09,00,07,00,01,e0,01,10,01,08,11,08,19,10,0f,e0,01,00,00,00",
	"00,00,38,02,44,04,44,08,44,10,44,20,44,40,38,80,01,1c,02,22,04,22,08,22,10,22,20,22,40,1c,00,00",
	"00,00,0f,00,18,80,10,80,11,80,1b,00,0e,7c,0c,10,1e,30,33,20,61,e0,40,c0,41,e2,23,36,1e,1c,00,00",
	"18,00,18,00,08,00,10,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00",
	"00,08,00,10,00,30,00,20,00,60,00,40,00,40,00,40,00,40,00,40,00,40,00,60,00,20,00,30,00,10,00,08",
	"10,00,08,00,0c,00,04,00,06,00,02,00,02,00,02,00,02,00,02,00,02,00,06,00,04,00,0c,00,08,00,10,00",
	"00,00,00,00,00,00,00,00,01,00,19,30,0d,60,07,c0,01,00,07,c0,0d,60,19,30,01,00,00,00,00,00,00,00",
	"00,00,00,00,01,00,01,00,01,00,01,00,01,00,3f,fc,01,00,01,00,01,00,01,00,01,00,01,00,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,60,00,60,00,20,00,40,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,00,00,3f,fc,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,60,00,60,00,00,00,00,00",
	"00,01,00,02,00,04,00,08,00,10,00,20,00,40,00,80,01,00,02,00,04,00,08,00,10,00,20,00,40,00,80,00",
// 30-3f
	"00,00,03,80,04,40,08,20,08,20,10,50,10,90,11,10,12,10,14,10,08,20,08,20,04,40,03,80,00,00,00,00",
	"00,00,03,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,00,00,00",
	"00,00,03,c0,04,20,08,10,08,10,00,10,00,20,00,40,00,80,01,00,02,00,04,00,08,00,0f,f0,00,00,00,00",
	"00,00,03,c0,04,20,08,10,08,10,00,10,00,20,00,c0,00,20,00,10,08,10,08,10,04,20,03,c0,00,00,00,00",
	"00,00,00,40,00,c0,01,40,01,40,02,40,04,40,04,40,08,40,10,40,10,40,3f,f0,00,40,00,40,00,00,00,00",
	"00,00,03,f0,02,00,02,00,04,00,04,00,07,c0,00,20,00,10,00,10,00,10,10,10,08,20,07,c0,00,00,00,00",
	"00,00,00,40,00,80,01,00,02,00,02,00,07,c0,0c,20,08,10,08,10,08,10,08,10,04,20,03,c0,00,00,00,00",
	"00,00,1f,f0,00,10,00,20,00,20,00,40,00,40,00,80,00,80,01,00,01,00,02,00,02,00,04,00,00,00,00,00",
	"00,00,03,c0,04,20,08,10,08,10,08,10,04,20,03,c0,04,20,08,10,08,10,08,10,04,20,03,c0,00,00,00,00",
	"00,00,03,c0,04,20,08,10,08,10,08,10,08,10,04,30,03,e0,00,40,00,40,00,80,01,00,02,00,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,01,80,01,80,00,00,00,00,00,00,00,00,01,80,01,80,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,01,80,01,80,00,00,00,00,00,00,00,00,01,80,01,80,00,80,01,00",
	"00,00,00,06,00,18,00,60,01,80,06,00,18,00,60,00,18,00,04,00,03,00,00,c0,00,20,00,18,00,06,00,00",
	"00,00,00,00,00,00,00,00,00,00,3f,fc,00,00,00,00,00,00,3f,fc,00,00,00,00,00,00,00,00,00,00,00,00",
	"00,00,60,00,18,00,06,00,01,80,00,60,00,18,00,06,00,18,00,20,00,c0,03,00,04,00,18,00,60,00,00,00",
	"00,00,07,e0,08,10,10,08,10,08,08,08,00,30,00,c0,01,00,01,00,00,00,00,00,01,80,01,80,00,00,00,00",
// 40-4f
//	"00,00,00,00,03,c0,0c,30,10,08,11,a8,22,64,24,44,24,44,24,c8,13,70,10,04,0c,18,03,e0,00,00,00,00",
	"00,00,01,00,02,80,02,80,04,40,04,40,7c,7c,20,08,10,10,08,20,08,20,11,10,12,90,2c,68,30,18,00,00",	// ＠→☆
	"00,00,00,00,01,00,01,00,02,80,02,80,04,40,04,40,08,20,08,20,0f,e0,10,10,10,10,78,3c,00,00,00,00",
	"00,00,00,00,1f,e0,04,10,04,08,04,08,04,10,07,e0,04,10,04,08,04,08,04,08,04,10,1f,e0,00,00,00,00",
	"00,00,00,00,03,d0,04,30,08,10,08,00,10,00,10,00,10,00,10,00,08,08,08,08,04,10,03,e0,00,00,00,00",
	"00,00,00,00,3f,80,08,60,08,10,08,08,08,08,08,08,08,08,08,08,08,08,08,10,08,60,3f,80,00,00,00,00",
	"00,00,00,00,3f,f0,08,10,08,08,08,40,08,40,0f,c0,08,40,08,40,08,00,08,08,08,10,3f,f0,00,00,00,00",
	"00,00,00,00,3f,f0,08,10,08,08,08,40,08,40,0f,c0,08,40,08,40,08,00,08,00,08,00,3e,00,00,00,00,00",
	"00,00,00,00,07,e0,08,20,10,10,10,00,20,00,20,00,20,f0,20,10,10,10,10,10,08,30,07,c0,00,00,00,00",
	"00,00,00,00,3e,7c,08,10,08,10,08,10,08,10,0f,f0,08,10,08,10,08,10,08,10,08,10,3e,7c,00,00,00,00",
	"00,00,00,00,07,c0,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,07,c0,00,00,00,00",
	"00,00,00,00,00,f8,00,20,00,20,00,20,00,20,00,20,00,20,08,20,18,20,10,20,08,40,07,80,00,00,00,00",
	"00,00,00,00,3e,3c,08,10,08,20,08,40,08,80,09,00,0a,80,0c,40,08,40,08,20,08,10,3e,3c,00,00,00,00",
	"00,00,00,00,3e,00,08,00,08,00,08,00,08,00,08,00,08,00,08,00,08,00,08,08,08,10,3f,f0,00,00,00,00",
	"00,00,00,00,f0,1e,30,18,28,28,28,28,24,48,24,48,24,48,22,88,22,88,21,08,21,08,f9,3e,00,00,00,00",
	"00,00,00,00,78,7c,18,10,14,10,12,10,12,10,11,10,10,90,10,90,10,50,10,30,10,30,7c,10,00,00,00,00",
	"00,00,00,00,03,80,0c,60,10,10,10,10,20,08,20,08,20,08,20,08,10,10,10,10,0c,60,03,80,00,00,00,00",
// 50-5f
	"00,00,00,00,3f,c0,08,20,08,10,08,10,08,20,0f,c0,08,00,08,00,08,00,08,00,08,00,3e,00,00,00,00,00",
	"00,00,00,00,03,80,0c,60,10,10,10,10,20,08,20,08,20,08,23,88,14,50,14,20,0c,60,03,94,00,08,00,00",
	"00,00,00,00,3f,c0,08,20,08,10,08,10,08,20,0f,c0,09,00,08,80,08,40,08,40,08,20,3e,38,00,00,00,00",
	"00,00,00,00,07,a0,08,60,10,20,10,00,08,00,07,00,00,c0,00,20,10,10,10,10,18,20,17,c0,00,00,00,00",
	"00,00,00,00,1f,f0,11,10,21,08,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,07,c0,00,00,00,00",
	"00,00,00,00,7c,7c,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,08,20,07,c0,00,00,00,00",
	"00,00,00,00,7c,7c,10,10,10,10,08,20,08,20,08,20,04,40,04,40,02,80,02,80,01,00,01,00,00,00,00,00",
	"00,00,00,00,e3,8e,41,04,41,04,22,88,22,88,22,88,14,50,14,50,14,50,08,20,08,20,08,20,00,00,00,00",
	"00,00,00,00,3c,78,08,20,04,40,04,40,02,80,01,00,01,00,02,80,04,40,04,40,08,20,3c,78,00,00,00,00",
	"00,00,00,00,7c,7c,10,10,08,20,08,20,04,40,02,80,01,00,01,00,01,00,01,00,01,00,07,c0,00,00,00,00",
	"00,00,00,00,0f,f8,08,08,10,10,00,20,00,40,00,80,01,00,02,00,04,00,08,08,10,10,1f,f0,00,00,00,00",
	"00,f8,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,f8",
//	"00,00,7c,3e,10,08,10,08,08,10,7f,fe,04,20,04,40,02,80,7f,fe,01,00,01,00,01,00,01,00,07,c0,00,00",
	"80,00,40,00,20,00,10,00,08,00,04,00,02,00,01,00,00,80,00,40,00,20,00,10,00,08,00,04,00,02,00,01",	// ￥→＼
	"1f,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,1f,00",
	"01,80,06,60,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,ff,ff",
// 60-6f
	"03,00,00,c0,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,03,c0,04,20,08,60,03,a0,04,20,08,20,08,60,07,b0,00,00,00,00",
	"00,00,00,00,0c,00,04,00,04,00,04,00,05,c0,06,20,04,10,04,10,04,10,04,10,06,20,05,c0,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,03,c0,04,20,08,10,08,00,08,00,08,10,04,20,03,c0,00,00,00,00",
	"00,00,00,00,00,c0,00,40,00,40,00,40,07,40,08,c0,10,40,10,40,10,40,10,40,08,c0,07,60,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,03,c0,04,20,08,10,0f,f0,08,00,08,00,04,30,03,e0,00,00,00,00",
	"00,00,00,00,00,e0,01,10,01,00,01,00,0f,e0,01,00,01,00,01,00,01,00,01,00,01,00,07,c0,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,03,a0,04,50,04,40,07,80,08,00,07,80,08,40,08,20,08,20,07,c0",
	"00,00,00,00,0c,00,04,00,04,00,04,00,05,80,06,40,04,20,04,20,04,20,04,20,04,20,0e,70,00,00,00,00",
	"00,00,00,00,01,00,01,00,00,00,00,00,03,00,01,00,01,00,01,00,01,00,01,00,01,00,03,80,00,00,00,00",
	"00,00,00,00,00,80,00,80,00,00,00,00,01,80,00,80,00,80,00,80,00,80,00,80,00,80,08,80,08,80,07,00",
	"00,00,00,00,18,00,08,00,08,00,08,00,08,e0,08,80,09,00,0a,00,0d,00,08,80,08,40,1c,70,00,00,00,00",
	"00,00,00,00,03,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,03,80,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,6c,60,32,90,21,08,21,08,21,08,21,08,21,08,73,9c,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,1b,80,0c,40,08,20,08,20,08,20,08,20,08,20,1c,70,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,03,80,04,40,08,20,08,20,08,20,08,20,04,40,03,80,00,00,00,00",
// 70-7e
	"00,00,00,00,00,00,00,00,00,00,00,00,0d,c0,06,20,04,10,04,10,04,10,04,10,06,20,05,c0,04,00,0e,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,07,40,08,c0,10,40,10,40,10,40,10,40,08,c0,07,40,00,40,00,e0",
	"00,00,00,00,00,00,00,00,00,00,00,00,06,e0,03,10,02,00,02,00,02,00,02,00,02,00,07,80,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,07,40,08,c0,08,40,07,00,00,c0,08,20,0c,20,0b,c0,00,00,00,00",
	"00,00,00,00,01,00,01,00,01,00,01,00,0f,e0,01,00,01,00,01,00,01,00,01,00,01,00,00,e0,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,18,e0,08,20,08,20,08,20,08,20,08,20,04,60,03,b0,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,1c,70,08,20,08,20,04,40,04,40,02,80,02,80,01,00,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,73,9c,21,08,22,88,12,90,14,50,14,50,08,20,08,20,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,1c,70,04,40,02,80,01,00,02,80,04,40,08,20,1c,70,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,1c,70,08,20,04,40,04,40,02,80,02,80,01,00,01,00,12,00,1c,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,0f,e0,08,40,10,80,01,00,02,00,04,20,08,40,1f,c0,00,00,00,00",
	"00,08,00,10,00,20,00,20,00,20,00,20,00,20,00,40,00,20,00,20,00,20,00,20,00,20,00,20,00,10,00,08",
	"01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00",
	"10,00,08,00,04,00,04,00,04,00,04,00,04,00,02,00,04,00,04,00,04,00,04,00,04,00,04,00,08,00,10,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,3c,00,43,01,80,c2,00,3c,00,00,00,00,00,00,00,00,00,00,00,00"
	//
}
dim str ptrn16k(16*4)={
// a1-af
	"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,60,00,90,00,90,00,60,00",
	"00,f8,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,80,00,00,00,00,00,00,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,1f,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,60,00,30,00,10,00",
	"00,00,00,00,00,00,00,00,00,00,00,00,00,00,01,80,01,80,00,00,00,00,00,00,00,00,00,00,00,00,00,00",
	"00,00,00,00,3f,fc,00,04,00,04,00,04,3f,fc,00,04,00,08,00,08,00,10,00,20,00,c0,0f,00,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,1f,f8,00,08,01,08,01,10,01,60,01,00,02,00,04,00,18,00,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,08,00,10,00,20,00,c0,03,40,1c,40,00,40,00,40,00,40,00,40,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,80,00,80,1f,f8,10,08,10,08,10,08,00,10,00,10,00,60,03,80,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,0f,f8,00,80,00,80,00,80,00,80,00,80,00,80,00,80,1f,fc,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,40,00,40,1f,f8,00,40,00,40,00,a0,01,20,06,20,18,20,00,20,00,00,00,00",
	"00,00,00,00,00,00,00,00,04,00,04,38,03,c8,1e,10,02,10,01,20,01,00,00,80,00,80,00,80,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,0f,c0,00,40,00,40,00,40,00,80,00,80,00,80,01,00,1f,f0,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,1f,f0,00,10,00,10,00,10,0f,f0,00,10,00,10,00,10,1f,f0,00,00,00,00",
	"00,00,00,00,00,00,00,00,00,00,01,08,11,08,10,88,08,88,08,10,00,10,00,20,00,c0,07,00,00,00,00,00",
// b0-bf
	"00,00,00,00,00,00,00,00,00,00,00,00,40,00,3f,fe,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00",
	"00,00,00,00,7f,fc,00,04,02,04,02,08,02,08,02,30,02,c0,02,00,04,00,04,00,18,00,60,00,00,00,00,00",
	"00,00,00,04,00,08,00,10,00,60,01,80,0e,80,70,80,00,80,00,80,00,80,00,80,00,80,00,80,00,00,00,00",
	"00,00,01,00,01,00,01,00,3f,fc,20,04,20,04,20,04,00,04,00,08,00,08,00,30,00,c0,07,00,00,00,00,00",
	"00,00,00,00,3f,f8,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,7f,fc,00,00,00,00",
	"00,00,00,40,00,40,00,40,3f,fc,00,40,00,40,00,a0,01,20,02,20,0c,20,30,20,00,20,00,20,00,00,00,00",
	"00,00,01,00,01,00,01,00,3f,fc,01,04,02,04,02,04,04,04,04,04,08,08,08,08,11,08,20,f0,00,00,00,00",
	"00,00,02,00,02,00,02,f0,7f,00,01,00,01,00,01,00,01,fc,7f,00,00,80,00,80,00,80,00,80,00,00,00,00",
	"00,00,00,00,07,f8,04,08,08,08,10,08,20,08,00,10,00,10,00,20,00,40,00,80,03,00,0c,00,00,00,00,00",
	"00,00,10,00,10,00,10,00,1f,fc,20,40,20,40,40,40,00,40,00,80,00,80,01,00,06,00,18,00,00,00,00,00",
	"00,00,00,00,3f,f8,00,08,00,08,00,08,00,08,00,08,00,08,00,08,00,08,00,08,00,08,3f,f8,00,00,00,00",
	"00,00,08,10,08,10,08,10,7f,fe,08,10,08,10,08,10,08,10,00,10,00,20,00,20,00,c0,07,00,00,00,00,00",
	"00,00,00,00,38,00,06,04,00,04,00,04,70,04,0c,04,00,08,00,08,00,10,00,20,01,c0,3e,00,00,00,00,00",
	"00,00,00,00,3f,f0,00,10,00,10,00,10,00,20,00,20,00,40,00,c0,01,20,06,10,18,08,60,04,00,00,00,00",
	"00,00,08,00,08,00,08,00,7f,fc,08,04,08,08,08,10,08,20,08,40,08,00,08,00,04,00,03,f8,00,00,00,00",
	"00,00,00,00,20,04,10,04,10,04,08,04,08,08,00,08,00,08,00,10,00,20,00,40,01,80,06,00,00,00,00,00",
// c0-cf
	"00,00,00,00,07,f8,04,08,08,08,10,08,2c,08,03,10,00,d0,00,20,00,40,00,80,03,00,0c,00,00,00,00,00",
	"00,00,00,00,00,78,3f,80,00,80,00,80,00,80,ff,fc,00,80,00,80,01,00,01,00,06,00,18,00,00,00,00,00",
	"00,00,00,00,01,04,21,04,20,84,10,84,10,84,10,04,00,08,00,08,00,10,00,20,00,c0,0f,00,00,00,00,00",
	"00,00,00,00,1f,f0,00,00,00,00,00,00,7f,fc,00,80,00,80,00,80,01,00,01,00,06,00,18,00,00,00,00,00",
	"00,00,20,00,20,00,20,00,20,00,20,00,3e,00,21,e0,20,18,20,00,20,00,20,00,20,00,20,00,00,00,00,00",
	"00,00,00,80,00,80,00,80,7f,fc,00,80,00,80,00,80,00,80,00,80,01,00,01,00,06,00,18,00,00,00,00,00",
	"00,00,00,00,3f,f8,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,7f,fc,00,00,00,00",
	"00,00,00,00,3f,fc,00,04,00,04,00,04,1c,08,03,08,00,d0,00,20,00,50,01,88,06,04,38,00,00,00,00,00",
	"01,00,01,00,01,00,3f,f8,00,08,00,10,00,20,00,c0,03,60,0d,18,71,04,01,02,01,00,01,00,00,00,00,00",
	"00,00,00,00,00,08,00,08,00,08,00,10,00,10,00,20,00,20,00,40,00,80,03,00,0c,00,70,00,00,00,00,00",
	"00,00,00,00,08,20,08,20,08,10,08,10,10,10,10,08,10,08,20,08,20,04,20,04,40,04,40,04,00,00,00,00",
	"00,00,20,00,20,00,20,00,20,18,21,e0,3e,00,20,00,20,00,20,00,20,00,20,00,20,00,1f,fc,00,00,00,00",
	"00,00,00,00,3f,fc,00,04,00,04,00,04,00,04,00,04,00,08,00,08,00,10,00,60,01,80,0e,00,00,00,00,00",
	"00,00,00,00,02,00,05,00,08,80,08,80,10,40,20,20,20,20,00,10,00,08,00,08,00,04,00,04,00,00,00,00",
	"00,00,01,00,01,00,01,00,7f,fc,01,00,01,00,09,20,09,10,11,08,11,08,21,04,41,04,01,00,00,00,00,00",
	"00,00,00,00,7f,fc,00,04,00,04,00,04,00,08,00,08,10,10,0c,60,03,80,01,00,00,80,00,40,00,00,00,00",
// d0-df
	"00,00,00,00,1f,c0,00,3c,00,00,00,00,00,00,1f,c0,00,38,00,00,00,00,00,00,3f,c0,00,3c,00,00,00,00",
	"00,00,00,00,02,00,02,00,04,00,04,00,08,00,08,00,10,10,10,10,20,08,20,08,40,04,7f,fc,00,00,00,00",
	"00,00,00,00,00,10,00,10,00,10,18,20,06,20,01,c0,00,60,00,98,01,04,02,00,0c,00,30,00,00,00,00,00",
	"00,00,00,00,3f,f8,04,00,04,00,04,00,04,00,7f,fc,04,00,04,00,04,00,04,00,04,00,03,f8,00,00,00,00",
	"00,00,08,00,08,00,08,7c,0f,84,74,08,04,08,02,10,02,20,02,00,01,00,01,00,01,00,01,00,00,00,00,00",
	"00,00,00,00,1f,f0,00,10,00,10,00,10,00,20,00,20,00,20,00,20,00,40,00,40,00,40,3f,fc,00,00,00,00",
	"00,00,00,00,3f,fc,00,04,00,04,00,04,00,04,1f,fc,00,04,00,04,00,04,00,04,00,04,3f,fc,00,00,00,00",
	"00,00,00,00,1f,f8,00,00,00,00,00,00,3f,fc,00,04,00,04,00,08,00,08,00,10,00,60,0f,80,00,00,00,00",
	"00,00,20,08,20,08,20,08,20,08,20,08,20,08,20,08,20,08,00,08,00,10,00,20,00,c0,0f,00,00,00,00,00",
	"00,00,10,80,10,80,10,80,10,80,10,80,10,82,10,82,10,82,10,84,20,84,20,88,40,b0,40,c0,00,00,00,00",
	"00,00,20,00,20,00,20,00,20,00,20,04,20,04,20,08,20,08,20,10,20,20,20,c0,23,00,3c,00,00,00,00,00",
	"00,00,00,00,3f,fc,20,04,20,04,20,04,20,04,20,04,20,04,20,04,20,04,20,04,20,04,3f,fc,00,00,00,00",
	"00,00,00,00,3f,fc,20,04,20,04,20,04,20,04,00,04,00,08,00,08,00,10,00,20,00,c0,07,00,00,00,00,00",
	"00,00,00,00,38,00,06,04,00,04,00,04,00,04,00,08,00,08,00,10,00,20,00,40,01,80,1e,00,00,00,00,00",
	"50,00,50,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00",
	"00,00,30,00,48,00,48,00,30,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00"
}
	dim int ptrn(16*16)
	int c
//	int x=0,y=0
	for c=&h20 to &h7e
		setSprite(ptrn16(c-&h20) ,c)
//		sp_pat(c,ptrn)
//		bitmapPattern(x*16,y*16,16,16,ptrn)
//		x=x+1
//		if x>=16 then x=0:y=y+1
	next
	for c=&ha1 to &hdf
		setSprite(ptrn16k(c-&ha1),c)
//		sp_pat(c,ptrn)
//		bitmapPattern(x*16,y*16,16,16,ptrn)
//		x=x+1
//		if x>=16 then x=0:y=y+1
	next
//	bitmapImgLoad()
endfunc

//****************************************************************
